diff -ur sourceold/scripts/MasterCan_Scripts.cpp source/scripts/MasterCan_Scripts.cpp
--- sourceold/scripts/MasterCan_Scripts.cpp	2019-03-31 08:17:14.582000000 +1000
+++ source/scripts/MasterCan_Scripts.cpp	2019-06-22 07:43:44.221400000 +1000
@@ -1229,7 +1925,16 @@
 /* Working */ ScriptRegistrant<MC_Spectate_Zone> MC_Spectate_Zone_Registrant("MC_Spectate_Zone", "");
 /* HasBugs */ ScriptRegistrant<MC_Beacon_Block_Zone> MC_Beacon_Block_Zone_Registrant("MC_Beacon_Block_Zone", "Red=16:int,Green=255:int,Blue=16:int,BlockMessage:string");
 /* Working */ ScriptRegistrant<MC_Objective_Message_Sender> MC_Objective_Message_Sender_Registrant("MC_Objective_Message_Sender", "Message=Use_Underscore_For_Space:string");
-/* Working */ ScriptRegistrant<MC_Objective_Controller> MC_Objective_Controller_Registrant("MC_Objective_Controller", "Objectives=Objective-Objects-IDs-Here-Minus-Is-Delimeter:string,MessageObject=100000:int");
-/* Working */ ScriptRegistrant<MC_Objective_Listener> MC_Objective_Listener_Registrant("MC_Objective_Listener", "Objective=100000:int,Trigger:string,CustomID:int,OnlyStarCanTrigger:int");
-/* Working */ ScriptRegistrant<MC_Objective> MC_Objective_Registrant("MC_Objective", "Message=Use_Underscore_For_Space:string,ObjectiveOrder=0:int,ObjectiveCompleteType=Must_be_KILLOBJECT_ENTER_POKE_or_NONE:string,StarTrigger=0:int,Listener=100000:int,ParameterObject=100000:int");
+/* Working */ ScriptRegistrant<MC_Objective_Controller> MC_Objective_Controller_Registrant("MC_Objective_Controller", "Objectives=Objective-Objects-IDs-Here-Minus-Is-Delimeter:string,MessageObject=100000:int,Debug=1:int");
+/* Working */ ScriptRegistrant<MC_Objective_Listener> MC_Objective_Listener_Registrant("MC_Objective_Listener", "Objective=100000:int,Trigger:string,CustomID:int,OnlyStarCanTrigger:int,Debug=1:int");
+/* Working */ ScriptRegistrant<MC_Objective> MC_Objective_Registrant("MC_Objective", "Message=Use_Underscore_For_Space:string,ObjectiveOrder=0:int,ObjectiveCompleteType=Must_be_KILLOBJECT_ENTER_POKE_or_NONE:string,StarTrigger=0:int,Listener=100000:int,ParameterObject=100000:int,Debug=1:int");
 /* Working */ ScriptRegistrant<MC_Destroy_When_Objective_Completed> MC_Destroy_When_Objective_Completed_Registrant("MC_Destroy_When_Objective_Completed", "ObjectiveArrow=100000:int");
+/* Working */ ScriptRegistrant<MC_Select_Weapon_On_Zone> MC_Select_Weapon_On_Zone_Registrant("MC_Select_Weapon_On_Zone", "EnterWeaponPreset:string,ExitWeaponPreset:string");
+/* Working */ ScriptRegistrant<MC_Select_Weapon_On_Zone_Enter> MC_Select_Weapon_On_Zone_Enter_Registrant("MC_Select_Weapon_On_Zone_Enter", "WeaponPreset:string");
+/* Working */ ScriptRegistrant<MC_Select_Weapon_On_Zone_Exit> MC_Select_Weapon_On_Zone_Exit_Registrant("MC_Select_Weapon_On_Zone_Exit", "WeaponPreset:string");
+/* Working */ ScriptRegistrant<MC_Chinook_Reinforcements_Paradrop> MC_Chinook_Reinforcements_Paradrop_Registrant("MC_Chinook_Reinforcements_Paradrop", "FirstPreset:string,SecondPreset:string,ThirdPreset:string,Debug=1:int");
+/* Working */ ScriptRegistrant<MC_Unkillable_Until_Custom> MC_Unkillable_Until_Custom_Registrant("MC_Unkillable_Until_Custom", "Message:int");
+/* Working */ ScriptRegistrant<MC_AttachScript_On_Kill> MC_AttachScript_On_Kill_Registrant("MC_AttachScript_On_Kill", "ObjectID:int,Script:string,Parameters:string");
+/* Working */ ScriptRegistrant<MC_AttachScript_Interval_Self> MC_AttachScript_Interval_Self_Registrant("MC_AttachScript_Interval_Self", "Script:string,Parameters:string,LoopCount=-1:int");
+/* Working */ ScriptRegistrant<MC_AttachScript_Interval> MC_AttachScript_Interval_Registrant("MC_AttachScript_Interval", "ObjectID:int,Script:string,Parameters:string,LoopCount=-1:int");
+/* Working */ ScriptRegistrant<MC_Private_Color_Message_On_Poke> MC_Private_Color_Message_On_Poke_Registrant("MC_Private_Color_Message_On_Poke", "Red=255:int,Green=255:int,Blue=255:int,Message=Message:string");
\ No newline at end of file
diff -ur sourceold/scripts/PhysicsSceneClass.h source/scripts/PhysicsSceneClass.h
--- sourceold/scripts/PhysicsSceneClass.h	2019-03-31 08:17:14.583000000 +1000
+++ source/scripts/PhysicsSceneClass.h	2019-06-22 07:43:44.222400000 +1000
@@ -250,7 +250,9 @@
 	void Post_Load_Level_Dynamic_Data(void);
 	void Set_Polygon_Budgets(int static_count,int dynamic_count);
 	void Get_Polygon_Budgets(int * static_count,int * dynamic_count);
+#ifdef TT_EXPORTS
 	void Refresh_Polygon_Budgets();
+#endif
 	void Set_Update_Only_Visible_Objects(bool b) { UpdateOnlyVisibleObjects=b; }
 	bool Get_Update_Only_Visible_Objects() { return UpdateOnlyVisibleObjects; }
 	virtual void Add_Render_Object(RenderObjClass * obj);
@@ -391,7 +393,7 @@
 	static bool AllowCollisionFlags[NUM_COLLISION_FLAGS];
 	int DynamicPolyBudget;
 	int StaticPolyBudget;
-#ifndef TTLE_EXPORTS
+#ifdef TT_EXPORTS
 	float mapStaticPolyBudget;
 	float mapDynamicPolyBudget;
 #endif
diff -ur sourceold/scripts/SoldierGameObjDef.h source/scripts/SoldierGameObjDef.h
--- sourceold/scripts/SoldierGameObjDef.h	2018-11-17 10:23:57.089600000 +1000
+++ source/scripts/SoldierGameObjDef.h	2019-06-22 07:43:44.223400000 +1000
@@ -62,6 +62,11 @@
 	friend	class								SoldierGameObj;
 	friend	class								SoldierObserverClass;
 	friend class PresetDump;
+public:
+	bool	GetInnateBehavior(){ return UseInnateBehavior;}
+	float	GetInnateAggressiveness(){ return InnateAggressiveness;}
+	float	GetInnateTakeCoverProbability(){ return InnateTakeCoverProbability;}
+	bool	GetInnateIsStationary(){ return InnateIsStationary;}
 }; // size: 912
 
 
diff -ur sourceold/scripts/VisTableClass.h source/scripts/VisTableClass.h
--- sourceold/scripts/VisTableClass.h	2018-10-27 22:04:56.356400000 +1000
+++ source/scripts/VisTableClass.h	2019-06-22 07:43:44.224400000 +1000
@@ -1,118 +1,118 @@
-/*	Renegade Scripts.dll
-	Copyright 2013 Tiberian Technologies
-
-	This file is part of the Renegade scripts.dll
-	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
-	the terms of the GNU General Public License as published by the Free
-	Software Foundation; either version 2, or (at your option) any later
-	version. See the file COPYING for more details.
-	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
-	Only the source code to the module(s) containing the licenced code has to be released.
-*/
-#ifndef TT_INCLUDE__VISTABLECLASS_H
-#define TT_INCLUDE__VISTABLECLASS_H
-
-
-
-#include "engine_vector.h"
-#include "multilist.h"
-
-
-class CompressedVisTableClass;
-class VisTableClass :
-	public RefCountClass,
-	public MultiListObjectClass
-{
-
-	int bitCount; // 0010  0028
-	union
-	{
-		byte* bytes; // 0014  002C
-		uint32* longs; // 0014  002C
-	};
-
-	int visSectorId; // 0018  0030
-	int timeStamp; // 001C  0034
-
-public:
-
-	VisTableClass(uint, int);
-	VisTableClass(CompressedVisTableClass*, int, int);
-	VisTableClass(const VisTableClass& that) { *this = that; }
-	~VisTableClass();
-	const VisTableClass& operator =(const VisTableClass& that);
-
-	void Alloc_Buffer(int);
-	byte* Get_Bytes() const { return bytes; }
-	int Get_Byte_Count() const { return 4 * Get_Long_Count(); }
-	uint32* Get_Longs() const { return longs; }
-	int Get_Long_Count() const;
-	void Reset_All();
-	void Set_All();
-	void Delete_Bit(int);
-	void Merge(const VisTableClass &that);
-	void Invert();
-	bool Is_Equal_To(const VisTableClass &that) const;
-	int Count_Differences(const VisTableClass &that) const;
-	int Count_True_Bits() const;
-	float Match_Fraction(const VisTableClass &that) const;
-	int Get_Bit_Count() const { return bitCount; }
-	void Set_Vis_Sector_ID(int _visSectorId) { visSectorId = _visSectorId; }
-	int Get_Vis_Sector_ID() const { return visSectorId; }
-	void Set_Time_Stamp(int _timeStamp) { timeStamp = _timeStamp; }
-	int Get_Time_Stamp() const { return timeStamp; }
-	bool Get_Bit(int) const;
-	void Set_Bit(int, bool);
-
-}; // 0020  0038
-
-class CompressedVisTableClass
-{
-public:
-	CompressedVisTableClass() : BufferSize(0), Buffer(0)
-	{
-	}
-	CompressedVisTableClass(VisTableClass *bits) : BufferSize(0), Buffer(0)
-	{
-		Compress(bits->Get_Bytes(),bits->Get_Byte_Count());
-	}
-	CompressedVisTableClass(CompressedVisTableClass &that) : BufferSize(0), Buffer(0)
-	{
-		*this = that;
-	}
-	~CompressedVisTableClass()
-	{
-		if (Buffer)
-		{
-			delete[] Buffer;
-		}
-	}
-	CompressedVisTableClass& operator=(const CompressedVisTableClass& that)
-	{
-		if (Buffer)
-		{
-			delete[] Buffer;
-		}
-		BufferSize = that.BufferSize;
-		Buffer = new unsigned char[BufferSize];
-		memcpy(Buffer,that.Buffer,BufferSize);
-		return *this;
-	}
-	unsigned char *Get_Bytes()
-	{
-		return Buffer;
-	}
-	int Get_Byte_Count()
-	{
-		return BufferSize;
-	}
-	void Load(ChunkLoadClass &cload);
-	void Save(ChunkSaveClass &csave);
-	void Compress(unsigned char *bytes,int src_size);
-	void Decompress(unsigned char *bytes,int src_size);
-private:
-	int BufferSize;
-	unsigned char *Buffer;
-};
-
+/*	Renegade Scripts.dll
+	Copyright 2013 Tiberian Technologies
+
+	This file is part of the Renegade scripts.dll
+	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+	the terms of the GNU General Public License as published by the Free
+	Software Foundation; either version 2, or (at your option) any later
+	version. See the file COPYING for more details.
+	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+	Only the source code to the module(s) containing the licenced code has to be released.
+*/
+#ifndef TT_INCLUDE__VISTABLECLASS_H
+#define TT_INCLUDE__VISTABLECLASS_H
+
+
+
+#include "engine_vector.h"
+#include "multilist.h"
+
+
+class CompressedVisTableClass;
+class VisTableClass :
+	public RefCountClass,
+	public MultiListObjectClass
+{
+
+	int bitCount; // 0010  0028
+	union
+	{
+		byte* bytes; // 0014  002C
+		uint32* longs; // 0014  002C
+	};
+
+	int visSectorId; // 0018  0030
+	int timeStamp; // 001C  0034
+
+public:
+
+	VisTableClass(uint, int);
+	VisTableClass(CompressedVisTableClass*, int, int);
+	VisTableClass(const VisTableClass& that);
+	~VisTableClass();
+	const VisTableClass& operator =(const VisTableClass& that);
+
+	void Alloc_Buffer(int);
+	byte* Get_Bytes() const { return bytes; }
+	int Get_Byte_Count() const { return 4 * Get_Long_Count(); }
+	uint32* Get_Longs() const { return longs; }
+	int Get_Long_Count() const;
+	void Reset_All();
+	void Set_All();
+	void Delete_Bit(int);
+	void Merge(const VisTableClass &that);
+	void Invert();
+	bool Is_Equal_To(const VisTableClass &that) const;
+	int Count_Differences(const VisTableClass &that) const;
+	int Count_True_Bits() const;
+	float Match_Fraction(const VisTableClass &that) const;
+	int Get_Bit_Count() const { return bitCount; }
+	void Set_Vis_Sector_ID(int _visSectorId) { visSectorId = _visSectorId; }
+	int Get_Vis_Sector_ID() const { return visSectorId; }
+	void Set_Time_Stamp(int _timeStamp) { timeStamp = _timeStamp; }
+	int Get_Time_Stamp() const { return timeStamp; }
+	bool Get_Bit(int) const;
+	void Set_Bit(int, bool);
+
+}; // 0020  0038
+
+class CompressedVisTableClass
+{
+public:
+	CompressedVisTableClass() : BufferSize(0), Buffer(0)
+	{
+	}
+	CompressedVisTableClass(VisTableClass *bits) : BufferSize(0), Buffer(0)
+	{
+		Compress(bits->Get_Bytes(),bits->Get_Byte_Count());
+	}
+	CompressedVisTableClass(CompressedVisTableClass &that) : BufferSize(0), Buffer(0)
+	{
+		*this = that;
+	}
+	~CompressedVisTableClass()
+	{
+		if (Buffer)
+		{
+			delete[] Buffer;
+		}
+	}
+	CompressedVisTableClass& operator=(const CompressedVisTableClass& that)
+	{
+		if (Buffer)
+		{
+			delete[] Buffer;
+		}
+		BufferSize = that.BufferSize;
+		Buffer = new unsigned char[BufferSize];
+		memcpy(Buffer,that.Buffer,BufferSize);
+		return *this;
+	}
+	unsigned char *Get_Bytes()
+	{
+		return Buffer;
+	}
+	int Get_Byte_Count()
+	{
+		return BufferSize;
+	}
+	void Load(ChunkLoadClass &cload);
+	void Save(ChunkSaveClass &csave);
+	void Compress(unsigned char *bytes,int src_size);
+	void Decompress(unsigned char *bytes,int src_size);
+private:
+	int BufferSize;
+	unsigned char *Buffer;
+};
+
 #endif
\ No newline at end of file
diff -ur sourceold/scripts/dllmain.cpp source/scripts/dllmain.cpp
--- sourceold/scripts/dllmain.cpp	2018-11-17 10:23:57.133600000 +1000
+++ source/scripts/dllmain.cpp	2019-06-22 07:43:44.225400000 +1000
@@ -376,6 +376,8 @@
 	Set_Camera_Host_Network = (schn)Address(tt,"Set_Camera_Host_Network");
 	Get_Pathfind_Distance = (gpd)Address(tt,"Get_Pathfind_Distance");
 	Cancel_Get_Pathfind_Distance = (cgpd)Address(tt,"Cancel_Get_Pathfind_Distance");
+	Get_Pathfind_Distance_Async = (gpda)Address(tt, "Get_Pathfind_Distance_Async");
+	Get_Pathfind_Distance_Blocking = (gpdb)Address(tt, "Get_Pathfind_Distance_Blocking");
 
 #ifdef SSGM
 	SSGMGameManager::Init();
diff -ur sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2018-11-17 10:23:57.178600000 +1000
+++ source/scripts/engine_tt.cpp	2019-06-22 07:43:44.226400000 +1000
@@ -225,7 +225,9 @@
 SCRIPTS_API fvup Force_Velocity_Update_Player;
 SCRIPTS_API schn Set_Camera_Host_Network;
 SCRIPTS_API gpd Get_Pathfind_Distance;
+SCRIPTS_API gpda Get_Pathfind_Distance_Async;
 SCRIPTS_API cgpd Cancel_Get_Pathfind_Distance;
+SCRIPTS_API gpdb Get_Pathfind_Distance_Blocking;
 
 SCRIPTS_API bool Can_Team_Build_Vehicle(int Team)
 {
diff -ur sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2018-11-17 10:23:57.179600000 +1000
+++ source/scripts/engine_tt.h	2019-06-22 07:43:44.227400000 +1000
@@ -181,7 +181,9 @@
 typedef void (*fvu) (GameObject *obj);
 typedef void (*fvup) (GameObject *player,GameObject *obj);
 typedef void (*schn) (GameObject *obj);
-typedef uint32 (*gpd) (const Vector3 &start, const Vector3 &dest, PathfindDistanceCallback callback, SmartGameObj *pathObj, void *data);
+typedef uint32(*gpd) (const Vector3& start, const Vector3& dest, PathfindDistanceCallback callback, SmartGameObj* pathObj, void* data);
+typedef uint32 (*gpda) (SmartGameObj* pathObj, const Vector3 &dest, PathfindDistanceCallback callback, void *data);
+typedef bool(*gpdb) (SmartGameObj* pathObj, const Vector3& dest, float& distanceResult, PathfindDistanceResult& pathfindResult);
 typedef bool (*cgpd) (uint32 id);
 SCRIPTS_API extern gpl Get_Player_List;
 SCRIPTS_API extern gcmi Get_Current_Map_Index;
@@ -365,8 +367,10 @@
 SCRIPTS_API extern fvu Force_Velocity_Update;
 SCRIPTS_API extern fvup Force_Velocity_Update_Player;
 SCRIPTS_API extern schn Set_Camera_Host_Network;
-SCRIPTS_API extern gpd Get_Pathfind_Distance; // Returns > 0 when succusful. May trigger callback function straight away. pathObj must be a vehicle or a soldier
-SCRIPTS_API extern cgpd Cancel_Get_Pathfind_Distance; // Cancels a pathfind distance request. Use the result from Get_Pathfind_Distance to cancel
+SCRIPTS_API extern gpd Get_Pathfind_Distance; // Deprecated, use Get_Pathfind_Distance_Async in stead
+SCRIPTS_API extern gpda Get_Pathfind_Distance_Async; // Returns > 0 when succusful. pathObj must be a vehicle or a soldier
+SCRIPTS_API extern cgpd Cancel_Get_Pathfind_Distance; // Cancels a pathfind distance request. Use the result from Get_Pathfind_Distance_Async/Get_Pathfind_Distance to cancel
+SCRIPTS_API extern gpdb Get_Pathfind_Distance_Blocking; // Returns > 0 when succesful. Solves distances immediately. pathObj must be a vehicle or a soldier
 
 class SCRIPTS_API JFW_Key_Hook_Base : public ScriptImpClass {
 public:
diff -ur sourceold/scripts/engine_ttdef.h source/scripts/engine_ttdef.h
--- sourceold/scripts/engine_ttdef.h	2018-10-27 22:04:56.432400000 +1000
+++ source/scripts/engine_ttdef.h	2019-06-22 07:43:44.228400000 +1000
@@ -93,8 +93,8 @@
 
 	}
 
-	PathfindDistanceRequest(const Vector3 &start, const Vector3 &dest, PathfindDistanceCallback callback, void *data) :
-		Id(0), Start(start), Dest(dest), PathSolver(nullptr), Result(PATHFIND_DISTANCE_INVALID_RESULT), Distance(0.0f), Callback(callback), Data(data)
+	PathfindDistanceRequest(uint32 id, const Vector3 &start, const Vector3 &dest, PathSolveClass* solver, PathfindDistanceCallback callback, void *data) :
+		Id(id), Start(start), Dest(dest), PathSolver(solver), Result(PATHFIND_DISTANCE_INVALID_RESULT), Distance(0.0f), Callback(callback), Data(data)
 	{
 
 	}
@@ -111,7 +111,6 @@
 
 	void Do_Callback()
 	{
-		PathSolver = nullptr;
 		Callback((*this));
 	}
 
diff -ur sourceold/scripts/gmbuilding.cpp source/scripts/gmbuilding.cpp
--- sourceold/scripts/gmbuilding.cpp	2018-11-17 10:23:57.185600000 +1000
+++ source/scripts/gmbuilding.cpp	2019-06-22 07:43:44.229400000 +1000
@@ -227,13 +227,7 @@
 		delete[] str2;
 		SSGMGameLog::Log_Message(str,"_BUILDING");
 	}
-	Vector3	victimpos =	Commands->Get_Position(obj);
-	Vector3	damagerpos = Commands->Get_Position(killer);
-	const char *str = Get_Translated_Preset_Name_Ex(obj);
-	const char *str2 = Get_Translated_Preset_Name_Ex(killer);
-	SSGMGameLog::Log_Gamelog("KILLED;BUILDING;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str,str2);
-	delete[] str;
-	delete[] str2;
+	Log_Killed_Message(obj, killer, "BUILDING");
 
 	if ( ((obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_ConstructionYardGameObj())) || (Is_Script_Attached(obj,"TDA_ConYard_Controller")) )
 	{
diff -ur sourceold/scripts/gmgame.cpp source/scripts/gmgame.cpp
--- sourceold/scripts/gmgame.cpp	2018-11-17 10:23:57.187600000 +1000
+++ source/scripts/gmgame.cpp	2019-06-22 07:43:44.230400000 +1000
@@ -181,6 +181,29 @@
 	return Get_Translated_Preset_Name_Part(obj);
 }
 
+SCRIPTS_API void Log_Killed_Message(GameObject *obj, GameObject *killer, const char *objectType)
+{
+	const char *killerPreset = Commands->Get_Preset_Name(killer);
+	const char *killerWeapon = Get_Current_Weapon(killer);
+	if (auto killerVehicle = Get_Vehicle(killer))
+	{
+		killerPreset = Commands->Get_Preset_Name(killerVehicle);
+		killerWeapon = Get_Current_Weapon(killerVehicle);
+	}
+
+	auto killedObj = obj;
+	if (auto killedVehicle = Get_Vehicle(obj))
+	{
+		killedObj = Get_Vehicle_Occupant(obj, 0);
+	}
+
+	Vector3	victimpos = Commands->Get_Position(obj);
+	Vector3	damagerpos = Commands->Get_Position(killer);
+	const char *str1 = Get_Translated_Preset_Name_Ex(obj);
+	const char *str2 = Get_Translated_Preset_Name_Ex(killer);
+	SSGMGameLog::Log_Gamelog("KILLED;%s;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s;%s;%s", objectType, Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer), killerPreset, int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)), killerWeapon, str1, str2, Get_Player_Name(killer), Get_Player_Name(killedObj));
+}
+
 SCRIPTS_API void RegisterEvent(EventType evt,Plugin *plugin)
 {
 	RegisteredEvents[evt].Add(plugin);
@@ -943,9 +966,10 @@
 	const char *str2 = Get_Translated_Definition_Name_Ini(Get_Definition_Name(preset));
 	const char *str3 = Get_Player_Name(purchaser);
 	str.Format("Purchase: %s - %s",str3,str2);
+	SSGMGameLog::Log_Message(str,"_PURCHASE");
+	SSGMGameLog::Log_Gamelog("PURCHASED;POWERUP;%s;%s;%s", str3, Get_Definition_Name(preset), str2);
 	delete[] str3;
 	delete[] str2;
-	SSGMGameLog::Log_Message(str,"_PURCHASE");
 	bool fp = FreePurchases;
 	for (int i = 0;i < RegisteredEvents[EVENT_POWERUP_PURCHASE_HOOK].Count();i++)
 	{
@@ -976,9 +1000,10 @@
 	const char *str2 = Get_Translated_Definition_Name_Ini(Get_Definition_Name(preset));
 	const char *str3 = Get_Player_Name(purchaser);
 	str.Format("Purchase: %s - %s",str3,str2);
+	SSGMGameLog::Log_Message(str,"_PURCHASE");
+	SSGMGameLog::Log_Gamelog("PURCHASED;VEHICLE;%s;%s;%s", str3, Get_Definition_Name(preset), str2);
 	delete[] str3;
 	delete[] str2;
-	SSGMGameLog::Log_Message(str,"_PURCHASE");
 	bool fp = FreePurchases;
 	for (int i = 0;i < RegisteredEvents[EVENT_VEHICLE_PURCHASE_HOOK].Count();i++)
 	{
@@ -1002,13 +1027,13 @@
 int SSGMGameManager::CharacterPurchaseHook(BaseControllerClass *base,GameObject *purchaser,unsigned int cost,unsigned int preset,const char *data)
 {
 	SSGM_Soldier *script = (SSGM_Soldier *)Find_Script_On_Object(purchaser,"SSGM_Soldier");
-  if (script && RefillLimit)
+	if (script && RefillLimit)
 	{
 		if (The_Game()->Get_Game_Duration_S() - script->RefillTime < RefillLimit)
 		{
 			return 4;
 		}
-  }
+	}
 	if (IsPresetDisabled(preset))
 	{
 		return 4;
@@ -1017,9 +1042,10 @@
 	const char *str2 = Get_Translated_Definition_Name_Ini(Get_Definition_Name(preset));
 	const char *str3 = Get_Player_Name(purchaser);
 	str.Format("Purchase: %s - %s",str3,str2);
+	SSGMGameLog::Log_Message(str,"_PURCHASE");
+	SSGMGameLog::Log_Gamelog("PURCHASED;CHARACTER;%s;%s;%s", str3, Get_Definition_Name(preset), str2);
 	delete[] str3;
 	delete[] str2;
-	SSGMGameLog::Log_Message(str,"_PURCHASE");
 	bool fp = FreePurchases;
 	for (int i = 0;i < RegisteredEvents[EVENT_CHARACTER_PURCHASE_HOOK].Count();i++)
 	{
diff -ur sourceold/scripts/gmgame.h source/scripts/gmgame.h
--- sourceold/scripts/gmgame.h	2018-11-17 10:23:57.188600000 +1000
+++ source/scripts/gmgame.h	2019-06-22 07:43:44.231400000 +1000
@@ -169,6 +169,7 @@
 SCRIPTS_API const char *Get_Translated_Preset_Name_Ex(GameObject *obj);
 SCRIPTS_API const char *Get_Translated_Preset_Name_Ini(GameObject *obj);
 SCRIPTS_API const char *Get_Translated_Definition_Name_Ini(const char *preset);
+SCRIPTS_API void Log_Killed_Message(GameObject *obj, GameObject *killer, const char *objectType);
 SCRIPTS_API void RegisterEvent(EventType evt,Plugin *plugin);
 SCRIPTS_API void UnregisterEvent(EventType evt,Plugin *plugin);
 SCRIPTS_API bool IsPresetDisabled(int preset);
diff -ur sourceold/scripts/gmsoldier.cpp source/scripts/gmsoldier.cpp
--- sourceold/scripts/gmsoldier.cpp	2018-11-17 10:23:57.191600000 +1000
+++ source/scripts/gmsoldier.cpp	2019-06-22 07:43:44.232400000 +1000
@@ -259,6 +259,8 @@
 {
 	if (!Commands->Is_A_Star(obj))
 	{
+		// Some plugins need bot controlled data too
+		Log_Killed_Message(obj, killer, "SOLDIER");
 		return;
 	}
 	GameObject *preset = GetExplosionObj();
@@ -311,13 +313,8 @@
 		delete[] str5;
 		SSGMGameLog::Log_Message(str,"_PLAYERKILL");
 	}
-	Vector3	victimpos =	Commands->Get_Position(obj);
-	Vector3	damagerpos = Commands->Get_Position(killer);
-	const char *str = Get_Translated_Preset_Name_Ex(obj);
-	const char *str2 = Get_Translated_Preset_Name_Ex(killer);
-	SSGMGameLog::Log_Gamelog("KILLED;SOLDIER;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str,str2);
-	delete[] str;
-	delete[] str2;
+
+	Log_Killed_Message(obj, killer, "SOLDIER");
 	Unbind_Vehicle(obj, true);
 	if (ExtraKillMessages)
 	{
diff -ur sourceold/scripts/gmvehicle.cpp source/scripts/gmvehicle.cpp
--- sourceold/scripts/gmvehicle.cpp	2018-11-17 10:23:57.194600000 +1000
+++ source/scripts/gmvehicle.cpp	2019-06-22 07:43:44.233400000 +1000
@@ -412,25 +412,15 @@
 		delete[] str6;
 		SSGMGameLog::Log_Message(str,"_VEHKILL");
 	}
+
+
 	if (Get_Vehicle_Mode(obj) == VEHICLE_TYPE_TURRET)
 	{
-		Vector3	victimpos =	Commands->Get_Position(obj);
-		Vector3	damagerpos = Commands->Get_Position(killer);
-		const char *str = Get_Translated_Preset_Name_Ex(obj);
-		const char *str2 = Get_Translated_Preset_Name_Ex(killer);
-		SSGMGameLog::Log_Gamelog("KILLED;BUILDING;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str,str2);
-		delete[] str;
-		delete[] str2;
+		Log_Killed_Message(obj, killer, "BUILDING");
 	}
 	else
 	{
-		Vector3	victimpos =	Commands->Get_Position(obj);
-		Vector3	damagerpos = Commands->Get_Position(killer);
-		const char *str3 = Get_Translated_Preset_Name_Ex(obj);
-		const char *str2 = Get_Translated_Preset_Name_Ex(killer);
-		SSGMGameLog::Log_Gamelog("KILLED;VEHICLE;%d;%s;%d;%d;%d;%d;%d;%s;%d;%d;%d;%d;%s;%s;%s",Commands->Get_ID(obj), Commands->Get_Preset_Name(obj), int(victimpos.Y), int(victimpos.X), int(victimpos.Z), int(Commands->Get_Facing(obj)), Commands->Get_ID(killer),	Commands->Get_Preset_Name(killer),	int(damagerpos.Y), int(damagerpos.X), int(damagerpos.Z), int(Commands->Get_Facing(killer)),Get_Current_Weapon(killer),str3,str2);
-		delete[] str3;
-		delete[] str2;
+		Log_Killed_Message(obj, killer, "VEHICLE");
 	}
 }
 
